% A class for preparation print mirrors on papers of arbitrary format
% for all kinds of bookbind, whether a sewn or a bind one.
%
% Started on the scrap of the former "book rearranger" mechanism by
% PeTaK on Sunday 28 of May, 2010.
%
\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{bookbind}[2010/12/11 class for shuffling and positioning single papges for printing books]

% class is based upon the generic article latex class                          
%                                                                              
\LoadClass{article}

% ----- deklaracie dolezitych rozmerov ------------------------------- 

\newdimen\bkbnd@lsep
\newdimen\bkbnd@rsep
\newdimen\bkbnd@tsep
\newdimen\bkbnd@bsep
\newdimen\bkbnd@mirrorhthalf

\newdimen\bkbnd@tol
\newdimen\bkbnd@tob
\newdimen\bkbnd@tor
\newdimen\bkbnd@tot

\newdimen\bkbnd@tel
\newdimen\bkbnd@teb
\newdimen\bkbnd@ter
\newdimen\bkbnd@tet

% ----- fyzicke rozmery materialu ------------------------------------

% velkost papiera A3
\def\bkbnd@paperwd{297mm}
\def\bkbnd@paperht{420mm}

% velkost zrkadla B4 (cize po prehnuti napoly B5)
\def\bkbnd@mirrorwd{238mm}
\def\bkbnd@mirrorht{328mm}

% a trosku zmensene zrkadlo pre potreby graphicsx
\def\bkbnd@mirrorwdint{232mm}
\def\bkbnd@mirrorhtint{328mm}

% ----- rozmery virtualnych struktur ---------------------------------

\def\bkbnd@ticklen{10mm}
\def\bkbnd@tickth{1mm}

\def\bkbnd@htuneshift{0mm}
\def\bkbnd@vtuneshift{0mm}
\def\bkbnd@finebundletune{0.01mm}

% ----- orezovacie rozmery -------------------------------------------

\bkbnd@tol=0mm
\bkbnd@tob=0mm
\bkbnd@tor=0mm
\bkbnd@tot=0mm

\bkbnd@tel=0mm
\bkbnd@teb=0mm
\bkbnd@ter=0mm
\bkbnd@tet=0mm

% ----- vypocty dolezitych rozmerov ----------------------------------

\def\bkbnd@recomputedims{%
    % compute the horizontal dimensions
    \bkbnd@lsep=\bkbnd@paperwd
    \advance\bkbnd@lsep by -\bkbnd@mirrorwd
    \advance\bkbnd@lsep by -\bkbnd@ticklen
    \advance\bkbnd@lsep by -\bkbnd@ticklen

    \bkbnd@rsep=\bkbnd@lsep
    \divide\bkbnd@lsep by 2
    \advance\bkbnd@rsep by -\bkbnd@lsep

    \advance\bkbnd@lsep by  \bkbnd@htuneshift
    \advance\bkbnd@rsep by -\bkbnd@htuneshift

    % compute the vertical dimensions
    \bkbnd@mirrorhthalf=\bkbnd@mirrorht
    \divide\bkbnd@mirrorhthalf by 2

    \bkbnd@tsep=\bkbnd@paperht
    \advance\bkbnd@tsep by -\bkbnd@mirrorht
    \advance\bkbnd@tsep by -\bkbnd@ticklen
    \advance\bkbnd@tsep by -\bkbnd@ticklen

    \bkbnd@bsep=\bkbnd@tsep
    \divide\bkbnd@tsep by 2
    \advance\bkbnd@bsep by -\bkbnd@tsep

    \advance\bkbnd@bsep by  \bkbnd@vtuneshift
    \advance\bkbnd@tsep by -\bkbnd@vtuneshift
}%

% vypocet treba okamzite aj vykonat
\bkbnd@recomputedims

% ----- mechamizny externeho ovplyvnovania geometrie ------------------

\def\setmirrorhbias#1{%
    \xdef\bkbnd@htuneshift{#1}%
    \bkbnd@recomputedims%
}%

\def\setmirrorvbias#1{%
    \xdef\bkbnd@vtuneshift{#1}%
    \bkbnd@recomputedims%
}%

\def\setticklength#1{%
    \xdef\bkbnd@ticklen{#1}%
    \bkbnd@recomputedims%
}%

\def\settickthickness#1{%
    \xdef\bkbnd@tickth{#1}%
}%

\def\settrimoddleft#1{%
    \bkbnd@tol=#1%
}%

\def\settrimoddbottom#1{%
    \bkbnd@tob=#1%
}%

\def\settrimoddright#1{%
    \bkbnd@tor=#1%
}%

\def\settrimoddtop#1{%
    \bkbnd@tot=#1%
}%

\def\settrimevenleft#1{%
    \bkbnd@tel=#1%
}%

\def\settrimevenbottom#1{%
    \bkbnd@teb=#1%
}%

\def\settrimevenright#1{%
    \bkbnd@ter=#1%
}%

\def\settrimeventop#1{%
    \bkbnd@tet=#1%
}%

\usepackage[noheadfoot,nomarginpar,a3paper,centering,total={\bkbnd@paperwd,\bkbnd@paperht}]{geometry}
\usepackage{graphicx}

% ----- samotne mechanizmy sadzby -----------------------------------

\def\bkbnd@rulebox#1#2{%
    {%
        \dimen1=#1%
        \dimen2=#2%
        \advance\dimen1 by -\bkbnd@tickth%
        \advance\dimen1 by -\bkbnd@tickth%
        \advance\dimen2 by -\bkbnd@tickth%
        \advance\dimen2 by -\bkbnd@tickth%
        \vbox to #2{%
            \hrule height \bkbnd@tickth depth 0mm%
            \hbox{%
                \vrule height \dimen2 width \bkbnd@tickth%
                \hskip \dimen1%
                \vrule height \dimen2 width \bkbnd@tickth%
            }%
            \vfil%
            \hrule height \bkbnd@tickth depth 0mm%
            \dp0=0mm%
        }%
    }%
}%

\def\bkbnd@dimbox#1#2{%
    \vbox{%
        \hbox{%
            \vbox to #2{%
                \hbox{%
                    \hskip #1%
                }%
                \vfil%
            }%
        }%
    }%
}%

\def\mirrorpage#1#2{%
    {%
        \baselineskip=0pt%
        \lineskip=0pt%
        \hbox{%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@ticklen}%
            \bkbnd@dimbox{\bkbnd@lsep}{\bkbnd@ticklen}%
            \bkbnd@rulebox{\bkbnd@mirrorwd}{\bkbnd@ticklen}%
            \bkbnd@dimbox{\bkbnd@rsep}{\bkbnd@ticklen}%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@ticklen}%
        }%
        \hbox{%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@tsep}%
            \bkbnd@dimbox{\bkbnd@lsep}{\bkbnd@tsep}%
            \bkbnd@dimbox{\bkbnd@mirrorwd}{\bkbnd@tsep}%
            \bkbnd@dimbox{\bkbnd@rsep}{\bkbnd@tsep}%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@tsep}%
        }%
        \hbox{%
            \bkbnd@rulebox{\bkbnd@ticklen}{\bkbnd@mirrorhthalf}%
            \bkbnd@dimbox{\bkbnd@lsep}{\bkbnd@mirrorhthalf}%
            \vbox to \bkbnd@mirrorhthalf{%
                \hsize=\bkbnd@mirrorwd%
                \noindent%
                \hrule height 0.5pt depth 0pt%
                \includegraphics[height=\bkbnd@mirrorwdint,clip,trim=\bkbnd@tol{} \bkbnd@tob{} \bkbnd@tor{} \bkbnd@tot,angle=270]{#1}\hfil%
                \hrule%
                \vfil%
            }%
            \bkbnd@dimbox{\bkbnd@rsep}{\bkbnd@mirrorhthalf}%
            \bkbnd@rulebox{\bkbnd@ticklen}{\bkbnd@mirrorhthalf}%
        }%
        \hbox{%
            \bkbnd@rulebox{\bkbnd@ticklen}{\bkbnd@mirrorhthalf}%
            \bkbnd@dimbox{\bkbnd@lsep}{\bkbnd@mirrorhthalf}%
            \vbox to \bkbnd@mirrorhthalf{%
                \hsize=\bkbnd@mirrorwd%
                \noindent%
                \vfil%
                \hrule%
                \includegraphics[height=\bkbnd@mirrorwdint,clip,trim=\bkbnd@tel{} \bkbnd@teb{} \bkbnd@ter{} \bkbnd@tet,angle=270]{#2}\hfil%
                \hrule height 0.5pt depth 0pt%
            }%
            \bkbnd@dimbox{\bkbnd@rsep}{\bkbnd@mirrorhthalf}%
            \bkbnd@rulebox{\bkbnd@ticklen}{\bkbnd@mirrorhthalf}%
        }%
        \hbox{%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@bsep}%
            \bkbnd@dimbox{\bkbnd@lsep}{\bkbnd@bsep}%
            \bkbnd@dimbox{\bkbnd@mirrorwd}{\bkbnd@bsep}%
            \bkbnd@dimbox{\bkbnd@rsep}{\bkbnd@bsep}%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@bsep}%
        }%
        \hbox{%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@ticklen}%
            \bkbnd@dimbox{\bkbnd@lsep}{\bkbnd@ticklen}%
            \bkbnd@rulebox{\bkbnd@mirrorwd}{\bkbnd@ticklen}%
            \bkbnd@dimbox{\bkbnd@rsep}{\bkbnd@ticklen}%
            \bkbnd@dimbox{\bkbnd@ticklen}{\bkbnd@ticklen}%
        }%
    }%
    \newpage%
}%

% ----- nastavenie zvysnych detailov sadzby -----------------------------

\pagestyle{empty}

